/*
** JabberX (Jabber Client)
** Copyright (c) 1999-2001 Gurer Ozen <palpa@jabber.org>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
** utility functions
*/

#include "common.h"


listitem *list_append(list **lis, void *data)
{
	listitem *li;

	if(!*lis)
	{
		*lis = malloc(sizeof(list));
		if(!*lis) return(NULL);
		memset(*lis, 0, sizeof(list));
	}

	li = (listitem *)data;
	li->next = NULL;
	li->prev = (*lis)->last;
	if(!(*lis)->first) (*lis)->first = li;
	if((*lis)->last) (*lis)->last->next = li;
	(*lis)->last = li;
	(*lis)->count++;

	return li;
}


listitem *list_prepend(list **lis, void *data)
{
	listitem *li;

	if(!*lis)
	{
		*lis = malloc(sizeof(list));
		if(!*lis) return(NULL);
		memset(*lis, 0, sizeof(list));
	}

	li = (listitem *)data;
	li->next = (*lis)->first;
	li->prev = NULL;
	if((*lis)->first) (*lis)->first->prev = li;
	(*lis)->first = li;
	if(!(*lis)->last) (*lis)->last = li;
	(*lis)->count++;

	return li;
}


void list_remove(list **lis, void *data)
{
	listitem *li = (listitem *)data;

	if((*lis)->first == li) (*lis)->first = li->next;
	if((*lis)->last == li) (*lis)->last = li->prev;
	if(li->prev) li->prev->next = li->next;
	if(li->next) li->next->prev = li->prev;
	(*lis)->count--;
}


void list_remove_all(list **lis)
{
	free(*lis);
	*lis = NULL;
}
